from dataclasses import dataclass, field
from datetime import datetime

@dataclass
class User():
	@property
	def mxid(self): return f'@{self.username}:{self.homeserver}'
	@mxid.setter
	def set_mxid(self,value):
		a=value.lstrip('@').split(':')
		self.username=a[0]; self.homeserver=a[1]
	username:str
	homeserver:str
	nick:str=''
	avatar:str=''

@dataclass
class Account(User):
	rooms:List[Room]=field(default_factory=list)

@dataclass
class Room():
	room_id:str
	name:str=''
	viewer:Account=None
	members:List[Member]=field(default_factory=list)
	@property
	def ismember(self): return self.viewer in self.members
	parents:List[Space]=field(default_factory=list)
	messages:List[Message]=field(default_factory=list)

@dataclass
class Space(Room):
	children:List[Room]=field(default_factory=list)

@dataclass
class Event():
	event_id:str
	author:Member
	timestamp:datetime
	contents:str=''

@dataclass
class Message(Event):
	format:str=''

@dataclass
class State(Event):
	key:str

@dataclass
class Member(User):
	room_av:str=''
	room_nick:str=''